﻿# Импортируем необходимые библиотеки
import numpy as np
import pylab as pl
from sklearn.svm import SVR
from sklearn.linear_model import LinearRegression
from numpy.random import random

# Задаем линейную функцию
def linear_func(x):
    return 3*x+2
# Епсилон (разброс)
eps = 10
# Количество исходных точек
N = 50
# Область определения функции
X = np.linspace(0,10,N)
# Генерируем количество индексов точек, для которых зададим разброс (шум)
M = int(N)
# Генерируем индексы точек, для которых будет задан разброс (остальные точки
# трогать не будем
I = random(M)*N
# Т.к. random() возвращает вещественные числа, то мы их отдельно приводим
# к целым
I = np.array(I, dtype=int)
# Задаем разброс [-eps; eps]
E = (2*random(M)-1)*eps
# Массив значений функции на области ее определения
Y = linear_func(X)
# Строим исходную функцию
pl.plot(X,Y)
# Для выбранных индексов генерируем шум
for i in range(M):
    j = I[i]
    Y[j]+=E[i]
# Строим множество точек (значение функции с учетом шума)
pl.scatter(X,Y)
# Меняем форму массива области определения функции (из одномерного массива
# делаем двумерный, в каждой строчке которого лежит одномерный массив (нужно
# т.к. классы SVR и LinearRegression рассчитаны на функции от многих переменных
X = np.reshape(X,(X.shape[0],1))
# Создаем класс SVR (Машина опорных точек), kernel='linear' означает, что мы гене
# рируем линейную функцию
clf = SVR(kernel='linear')
# На основе обучающего примера генерируем коэффициенты для линейной функции
clf.fit(X,Y)
# Уже обученный объект преобразовывает переданные точки в значения функции
Y1 = clf.predict(X)
# Сравниваем метод наименьших квадратов с методом машины опорных векторов
clf1 = LinearRegression()
# Обучаем объект метода наименьших квадратов
clf1.fit(X,Y)
# Обученный объект возвращает значения для переданного множества точек
Y2 = clf1.predict(X)
# Строим график для метода машины опорных векторов
pl.plot(X,Y1)
# Строим график для метода наименьших квадратов
pl.plot(X,Y2)
# Показываем графики
pl.show()
