﻿import numpy as np
import pylab as pl
from sklearn.linear_model import LinearRegression
from numpy.random import random

# Задаем функцию от двух переменных
def linear_func(x,y):
    return 3*x+4*y+1

# -------------Обучающий пример -----------
# Задаем разброс (шум)
eps = 3
# Генерируем координаты точек
# Генерируем X [-1,1]
X1 = 2*random(30)-1
# Генерируем Y [-1,1]
X2 = 2*random(30)-1
# Склеиваем два массива точек, получая пары (x,y) - координаты точек на пл-ти
XX0 = np.c_[X1,X2]
# Вычисляем значение функции с шумом ( отображение в цвета)
YY0 = linear_func(X1,X2)+(2*random(30)-1)*eps
# Создаем экземпляр класса
# ------------Обучающий пример создан-------------
clf = LinearRegression()
# Обучаем экземпляр на обучающем примере (подбираем значения a, b, c функции
clf.fit(XX0,YY0)

# ---------------- Создаем сетку ------------------
# Генерируем абсциссу сетки (ось)
x = np.linspace(-1,1,50)
# Генерируем ординату сетки (ось)
y = np.linspace(-1,1,50)
# Генерируем сетку, состоящую из всевозможных пар (x,y) xx - двумерный массив
# в котором содержатся значения точек по оси x, (содержатся в двумерной матрице)
# Т.е. элемент матрицы с координатами i, j является значением элемента двумерной
# сетки с координатами i, j, аналогично с yy
xx,yy = np.meshgrid(x,y)

# Вытягиваем массив xx в одномерный. Аналогично с yy. Склеиваем в двумерный
# и получаем всевозможные соответствия (пары) (x,y) нашей сетки
XX = np.c_[xx.ravel(),yy.ravel()]
# Передаем всю сетку, метод вычисляет значение цвета для каждой вершины сетки
YY = clf.predict(XX)
'''Строим сетку ( значение YY является значением цвета). Если вывести график
То увидим довольно резкие переходы между элементами сетки, это объясняется
 разными значениями цветов для каждого элемента сетки'''
cl = pl.pcolormesh(xx,yy,YY.reshape(xx.shape))
# Показываем столб с цветами-значениями
pl.colorbar(cl)
# Строим точки исходной функции (YY0 - значения цветов точек)
pl.scatter(X1,X2,c=YY0)
# Показываем график
pl.show()
