# coding=cp1251

import pylab as pl
def curve (func,a,b,label=None):
    from numpy import linspace
    from pylab import plot
    X=linspace(a,b,100)
    Y=[func(x) for x in X]
    p=plot (X,Y,label=label)
    return p




def varseq(X, label = None):
    from pylab import plot
    Y=list(X)
    Y.sort()
    Y.reverse()
    X=range(len(X))
    P=plot(X,Y,label='label')
    return P


def map (func,A,B,nlevels = 10, clabel = True, cmap=pl.cm.Blues):
    import numpy as np
    import pylab as pl
    x0, x1 = A
    y0, y1 = B
    X=np.linspace(x0, x1,50)
    Y=np.linspace(y0,y1,50)
    XX,YY=np.meshgrid(X,Y)
    XY = np.c_[XX.ravel(), YY.ravel()]
    Z = func(XY)
    Zmax,Zmin = np.max(Z), np.min(Z)
    zlevels = np.linspace(Zmin, Zmax, nlevels)
    ZZ = Z.reshape(XX.shape)
    cf1=pl.contourf(XX, YY, ZZ, levels = zlevels, cmap = cmap)
    if clabel:
        cf2=pl.contour(XX, YY, ZZ, levels = zlevels, colors='k',
                        antialiased=True, linewidths = 0.5)
        pl.clabel(cf2, colors='k', antialiased=True, fontsize=9)
    pl.colorbar(cf1)


def imshow (func,A,B,nlevels = 10, clabel = True, cmap=pl.cm.hot):
    import numpy as np
    import pylab as pl
    x0, x1 = A
    y0, y1 = B
    X=np.linspace(x0, x1,100)
    Y=np.linspace(y0,y1,100)
    XX,YY=np.meshgrid(X,Y)
    XY = np.c_[XX.ravel(), YY.ravel()]
    Z = func(XY)
    Zmax,Zmin = np.max(Z), np.min(Z)
    zlevels = np.linspace(Zmin, Zmax, nlevels)
    ZZ = Z.reshape(XX.shape)
    f = pl.imshow(ZZ, cmap=cmap)
    pl.colorbar(f)



def func(XY):
    import numpy as np
    R=XY[:,0]**2+XY[:,1]**2
    R1=(XY[:,0]-2)**2+(XY[:,1]-2)**2
    Z=np.exp(-R)-np.exp(-R1)
    return Z


def func1(XY):
    import numpy as np
    R=XY[:,0]**2+XY[:,1]**2
    Z=np.exp(-0.2*R)*np.sin(3*R)
    return Z


from math import sin,cos

def xsin(x):
    return x*sin(x)


pl.figure()
#map (func1, (-6,6), (-6,6), clabel=False, nlevels = 50)
imshow(func, (-6,6), (-6,6), cmap=pl.cm.RdYlBu)
pl.show()
#curve (xsin,0,10,label='xsin(x)')
#pl.show()
#from numpy.random import random
#varseq(random(1000))
#pl.legend()
#pl.show()






