import numpy as np
from numpy.random import random
from sklearn.neighbors import KNeighborsRegressor
import pylab as pl
#Zadaem kolichestvo tochek
N = 70
#Generiruem koordinati po X
X = 2*random(N)-1
#Generiruem koordinati po Y
Y = 2*random(N)-1
#Generiruem massiv koordinat
XY = np.c_[X,Y]
#Vichislyaem rasstojanie ot nacala koordinat
R = np.sqrt(X**2+Y**2)
#Vichislyaem znacheniya functsii
Z = np.exp(-R)*np.cos(3*R)
#Sozdaem exemplar klass KNeighborsRegressor, orientiruem na 5 sosedej
neig = KNeighborsRegressor(n_neighbors = 10, weights = 'distance')
#Obuchaem na primere
neig.fit(XY,Z)

pl.figure()
X2=np.linspace(-1,1,50)
Y2 = np.linspace(-1,1,50)
XX2, YY2 = np.meshgrid(X2,Y2)
XY2 = np.c_[XX2.ravel(),YY2.ravel()]
R2 = np.sqrt(XY2[:,0]**2+XY2[:,1]**2)
Z2 = np.exp(-R2)*np.cos(3*R2)
zmin2, zmax2 = np.min(Z2), np.max(Z2)
zlevels2 = np.linspace(zmin2,zmax2,20)
cf2 = pl.contourf(XX2,YY2,Z2.reshape(XX2.shape),alpha=0.5, levels=zlevels2)
pl.colorbar(cf2)
pl.figure()

pl.scatter(X,Y,c=Z)

X1 = np.linspace(-1,1,50)
Y1 = np.linspace(-1,1,50)
XX1,YY1=np.meshgrid(X1,Y1)
XY1 = np.c_[XX1.ravel(),YY1.ravel()]
Z1 = neig.predict(XY1)
ZZ1 = Z1.reshape(XX1.shape)
zmin, zmax = np.min(ZZ1), np.max(ZZ1)
zlevels = np.linspace(zmin,zmax,20)
cf1 = pl.contourf(XX1,YY1,ZZ1,alpha=0.5, levels=zlevels)
pl.colorbar(cf1)
pl.show()
